unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, DB, DBClient, Grids, DBGrids, StdCtrls, ExtCtrls, DBCtrls, DateUtils;

type
  TformMain = class(TForm)
    MainMenu1: TMainMenu;
    mnuDatei: TMenuItem;
    mnuOeffnen: TMenuItem;
    mnuExportieren: TMenuItem;
    mnuBeenden: TMenuItem;
    mnuAbout: TMenuItem;
    cds1: TClientDataSet;
    cds1ID: TAutoIncField;
    cds1Datum: TDateField;
    cds1Titel: TStringField;
    cds1Stichworte: TStringField;
    OpenDialog1: TOpenDialog;
    mnuSpeichern: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    SaveDialog1: TSaveDialog;
    GroupBox1: TGroupBox;
    ebxDatum: TEdit;
    ebxTitel: TEdit;
    ebxStichworte: TEdit;
    ebxBeschreibung: TMemo;
    mnuSpeichernunter: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    cds1Beschreibung: TMemoField;
    GroupBox2: TGroupBox;
    btnFirst: TButton;
    btnPrior: TButton;
    btnNext: TButton;
    btnLast: TButton;
    btnNew: TButton;
    GroupBox3: TGroupBox;
    btnDelete: TButton;
    btnUebernehmen: TButton;
    Label9: TLabel;
    Label10: TLabel;
    ebxDsnr: TEdit;
    ebxDsanzahl: TEdit;
    lbxTitel: TListBox;
    SaveDialog2: TSaveDialog;
    GroupBox4: TGroupBox;
    panAlle: TPanel;
    btnAlle: TButton;
    panDatum: TPanel;
    Label6: TLabel;
    cbxDatum: TComboBox;
    panTitel: TPanel;
    Label7: TLabel;
    cbxBuchstabe: TComboBox;
    panStichwort: TPanel;
    Label8: TLabel;
    cbxStichwort: TComboBox;
    panSuchen: TPanel;
    ebxSuchen: TEdit;
    btnSuchen: TButton;
    Label11: TLabel;
    Label12: TLabel;
    panSpeziell: TPanel;
    cbxSpeziell: TComboBox;
    Label13: TLabel;
    panAllgemein: TPanel;
    btnAllgemein: TButton;
    cds1Speziell: TStringField;
    Label14: TLabel;
    Label15: TLabel;
    ebxSpeziell: TEdit;
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuBeendenClick(Sender: TObject);
    procedure mnuOeffnenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnuSpeichernClick(Sender: TObject);
    procedure btnFirstClick(Sender: TObject);
    procedure btnPriorClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnLastClick(Sender: TObject);
    procedure mnuSpeichernunterClick(Sender: TObject);
    procedure btnUebernehmenClick(Sender: TObject);
    procedure btnNewClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure lbxTitelClick(Sender: TObject);
    procedure btnAlleClick(Sender: TObject);
    procedure cbxDatumChange(Sender: TObject);
    procedure cbxSpeziellChange(Sender: TObject);
    procedure cbxBuchstabeChange(Sender: TObject);
    procedure cbxStichwortChange(Sender: TObject);
    procedure btnSuchenClick(Sender: TObject);
    procedure mnuExportierenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnAllgemeinClick(Sender: TObject);


  private
    aktuelleDatei: string;
    modified: integer;
  public
    { Public declarations }
  end;

   type Tdatensatz = Record
        ID: integer;
        Datum: string;
        Titel: string;
        Stichworte: string;
        Beschreibung: string;
    end;
    type TStringDynArray = array of string;

    function Explode(const Separator, S: string; Limit: Integer = 0): TStringDynArray; forward;
    procedure dsaktualisieren(); forward;
    procedure cbxaktualisieren(); forward;
    procedure lbxaktualisieren(); forward;
    procedure moduszeigen(modus: string); forward;
    procedure speichern(); forward;

var
  formMain: TformMain;

implementation //#####################################################

uses Unit2;

{$R *.dfm}

procedure TformMain.FormCreate(Sender: TObject);
begin
  // Init
    modified := 0;
    opendialog1.InitialDir := application.ExeName;
    savedialog1.InitialDir := application.ExeName;
    savedialog2.InitialDir := application.ExeName;
    moduszeigen('alle');
end;

procedure TformMain.mnuBeendenClick(Sender: TObject);
begin
  // Programm beenden
    formMain.Close;
end;

procedure TformMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  speichern();
end;

procedure TformMain.mnuAboutClick(Sender: TObject);
begin
  // Aboutform zeigen
    formAbout.visible := true;
end;

//------------------------------------------------------

procedure TformMain.mnuOeffnenClick(Sender: TObject);
begin
  // Daten speichern?
    speichern();
  // Datei ffnen
  if (opendialog1.Execute) then
  begin
    cds1.Filter := '';
    cds1.Filtered := false;
    moduszeigen('alle');
    cds1.loadfromfile(opendialog1.FileName);
    mnuSpeichern.Enabled := true;
    mnuSpeichernunter.Enabled := true;
    mnuExportieren.Enabled := true;
    cds1.RecNo := cds1.RecordCount;
    dsaktualisieren();
    cbxaktualisieren();
    lbxaktualisieren();
    aktuelleDatei := opendialog1.FileName;
    mnuSpeichern.Enabled := true;
  end;
end;

procedure TformMain.mnuSpeichernClick(Sender: TObject);
begin
  // Daten speichern
  if aktuelleDatei <> '' then
  begin
    cds1.savetofile(aktuelleDatei, dfXML);
    modified := 0;
  end
  else
  begin
    showmessage('Speichern nicht mglich.' + chr(13)
                + 'Evtl. "Speichern unter" whlen');
  end;
end;

procedure TformMain.mnuSpeichernunterClick(Sender: TObject);
begin
  mnuSpeichern.Enabled := true;
  // Daten speichern unter
  if (savedialog1.Execute) then
  begin
    cds1.savetofile(savedialog1.FileName, dfXML);
    aktuelleDatei := savedialog1.FileName;
    modified := 0;
  end;
end;

procedure TformMain.mnuExportierenClick(Sender: TObject);
  var i,ii,stelle,alterindex,higharrayx,minpos: integer;
  var datensaetze: array of array of string;
  var harray: array of string;
  var h: string;
  var f: textfile;
begin                             // Datenstze in HTML exportieren
  // Array erstellen
  if formMain.cds1.RecordCount > 0 then
  begin
    // alten Index speichern
      alterindex := formMain.cds1.RecNo;
    setlength(datensaetze, formMain.cds1.RecordCount, 4);
    for i := 1 to formMain.cds1.RecordCount do
    begin
      formMain.cds1.RecNo := i;
      datensaetze[i-1, 0] := vartostr(formMain.cds1.FieldValues['Datum']);
      datensaetze[i-1, 1] := vartostr(formMain.cds1.FieldValues['Speziell']);
      datensaetze[i-1, 2] := vartostr(formMain.cds1.FieldValues['Titel']);
      datensaetze[i-1, 3] := vartostr(formMain.cds1.FieldValues['Beschreibung']);
    end;

    // Array sortieren   /////////////////////////////////////////////////////
    higharrayx := formMain.cds1.RecordCount;
    setlength(harray, 4);
    for i := 0 to higharrayx - 1 do
    begin
      minpos := i;
      for ii := i+1 to higharrayx - 1 do
      begin
        if comparedate(strtodate(datensaetze[ii, 0]),strtodate(datensaetze[minpos, 0])) > 0 then
        begin
          minpos := ii;
        end;
      end;
      harray[0] := datensaetze[i, 0];
      harray[1] := datensaetze[i, 1];
      harray[2] := datensaetze[i, 2];
      harray[3] := datensaetze[i, 3];
      datensaetze[i, 0] := datensaetze[minpos, 0];
      datensaetze[i, 1] := datensaetze[minpos, 1];
      datensaetze[i, 2] := datensaetze[minpos, 2];
      datensaetze[i, 3] := datensaetze[minpos, 3];
      datensaetze[minpos, 0] := harray[0];
      datensaetze[minpos, 1] := harray[1];
      datensaetze[minpos, 2] := harray[2];
      datensaetze[minpos, 3] := harray[3];
    end;
    // alten Index wiederherstellen
      formMain.cds1.RecNo := alterindex;
  end;

  // HTML-Datei schreiben
  if (savedialog2.Execute) then
  begin
    assignfile(f,savedialog2.FileName);
    rewrite(f);
      // Header
        writeln(f, '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">');
        writeln(f, '<html xml:lang="de" xmlns="http://www.w3.org/1999/xhtml">');
        writeln(f, '<head>');
        writeln(f, '  <title>BeVerLi - Daten-Export</title>');
        writeln(f, '  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />');
        writeln(f, '  <meta http-equiv="content-language" content="de" />');
        writeln(f, '  <meta name="author" content="ESW  by Meillo  r e t u r n s">');
        writeln(f, '  <meta name="generator" content="BeVerLi - Das Beschluss-Verzeichnis">');
        writeln(f, '  <style type="text/css">');
        writeln(f, '    <!--');
        writeln(f, '    body { font-family: sans-serif; font-size: 1em; margin: 2em; }');
        writeln(f, '    p { margin: 0px; }');
        writeln(f, '    h2 { font-size: 1.2em; font-weight: bold; color: #89290a; margin-bottom: 2em; }');
        writeln(f, '    a:link { color: #000; text-decoration: underline; }');
        writeln(f, '    table { border: #ccc 1px solid; }');
        writeln(f, '    td { padding: 0.3em 1em; vertical-align: top; }');
        writeln(f, '    th { padding: 0.3em 1em; text-align: left; }');
        writeln(f, '    .tr1 { background-color: #eee; }');
        writeln(f, '    .tr2 { background-color: #ddd; }');
        writeln(f, '    #footer { font-size: 0.8em; margin-top: 2em; }');
        writeln(f, '    //-->');
        writeln(f, '  </style>');
        writeln(f, '</head>');
        writeln(f, '');
        writeln(f, '<body style="background-color: #fffbf0;">');
        writeln(f, '  <h2>BeVerLi - Daten-Export</h2>');
        writeln(f, '  <table>');
        writeln(f, '    <tr style="background-color: #666; color: #fffbf0">');
        writeln(f, '      <th>Datum:</th>');
        writeln(f, '      <th>Kategorie:</th>');
        writeln(f, '      <th>Titel:</th>');
        writeln(f, '      <th>Beschreibung:</th>');
        writeln(f, '    </tr>');
        writeln(f, '');
      // Daten
      for i:=formMain.cds1.RecordCount-1 downto 0 do
      begin
        if i mod 2 = 0 then
        begin
          writeln(f, '    <tr class="tr2">');
        end
        else
        begin
          writeln(f, '    <tr class="tr1">');
        end;
        for ii:=0 to 3 do
        begin
          writeln(f, '      <td>');
          if datensaetze[i,ii] = '' then
          begin
            writeln(f, '        &nbsp;');
          end
          else
          begin
            // '/n' mit '<br />' ersetzen
            h := datensaetze[i,ii];
            while pos(chr(13),h) <> 0 do
            begin
              stelle := pos(chr(13),h);
              delete(h, stelle, 1);
              insert('<br />', h, stelle);
            end;
            writeln(f, '        ' + h);
          end;
          writeln(f, '      </td>');
        end;
        writeln(f, '    </tr>');
      end;
      // Footer
        writeln(f, '  </table>');
        writeln(f, '  <p id="footer">Dieses Dokument wurde mit <a href="http://www.beverli.de.vu">BeVerLi</a> erstellt.</p>');
        writeln(f, '</body>');
        writeln(f, '</html>');
        writeln(f, '');
        writeln(f, '<!--  ##  ##   Code-Design by ESW | "Meillo  r e t u r n s"   ##  ##  //-->');
    closefile(f);
  end;
end;

//-------------------------------------------------------------

procedure TformMain.btnFirstClick(Sender: TObject);
begin
  cds1.First;
  dsaktualisieren();
  lbxaktualisieren();
end;

procedure TformMain.btnPriorClick(Sender: TObject);
begin
  cds1.Prior;
  dsaktualisieren();
  lbxaktualisieren();
end;

procedure TformMain.btnNextClick(Sender: TObject);
begin
  cds1.Next;
  dsaktualisieren();
  lbxaktualisieren();
end;

procedure TformMain.btnLastClick(Sender: TObject);
begin
  cds1.Last;
  dsaktualisieren();
  lbxaktualisieren();
end;

procedure TformMain.btnNewClick(Sender: TObject);
begin
  cds1.Filter := '';
  cds1.Filtered := false;
  moduszeigen('alle');
  cds1.Append;
  dsaktualisieren();
end;

//--------------------------------------------------------


procedure TformMain.btnDeleteClick(Sender: TObject);
  var alterindex: integer;
begin
  if MessageDlg('Den Eintrag wirklich lschen?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    if formMain.cds1.RecordCount <> 0 then
    begin
      // alten Index speichern
        alterindex := formMain.cds1.RecNo;
      cds1.Delete;
      modified := 1;
      cds1.Filtered := false;
      dsaktualisieren();
      cbxaktualisieren();
      cds1.Filtered := true;
      // alten Index setzen
        if formMain.cds1.RecordCount >= alterindex then
        begin
          formMain.cds1.RecNo := alterindex;
        end
        else
        begin
          formMain.cds1.RecNo := formMain.cds1.RecordCount;
        end;
      lbxaktualisieren();
    end;
  end;
end;

procedure TformMain.btnUebernehmenClick(Sender: TObject);
begin
  // in DB schreiben
  if (ebxTitel.Text <> '') then
  begin
    cds1.Edit;
      if (ebxDatum.text <> '') then
      begin
        cds1.FieldValues['Datum'] := ebxDatum.text;
      end;
      cds1.fieldvalues['Titel'] := ebxTitel.Text;
      cds1.FieldValues['Speziell'] := ebxSpeziell.Text;
      if (ebxStichworte.Text <> '') then
      begin
        cds1.FieldValues['Stichworte'] := ebxStichworte.Text;
      end;
      if (ebxBeschreibung.Text <> '') then
      begin
        cds1.FieldValues['Beschreibung'] := ebxBeschreibung.Text;
      end;
    cds1.Post;
    formMain.cds1.RecNo := formMain.cds1.RecordCount;
    cbxaktualisieren();
    lbxaktualisieren();
    modified := 1;
  end
  else
  begin
    showmessage('Du musst einen Titel eingeben');
  end;
end;


//------------------------------------------------------------------------

procedure TformMain.lbxTitelClick(Sender: TObject);
begin
  cds1.RecNo := cds1.RecordCount - lbxTitel.ItemIndex;
  dsaktualisieren();
  lbxaktualisieren();
end;

//---------------------------------------------------------------------------

procedure TformMain.btnAlleClick(Sender: TObject);
begin
  cds1.Filter := '';
  cds1.Filtered := false;
  moduszeigen('alle');
  cds1.RecNo := cds1.RecordCount;
  dsaktualisieren();
  lbxaktualisieren();
end;

procedure TformMain.btnAllgemeinClick(Sender: TObject);
begin
  cds1.Filter := 'Speziell = ' + quotedstr('');
  cds1.Filtered := true;
  moduszeigen('allgemein');
  cds1.RecNo := cds1.RecordCount;
  dsaktualisieren();
  lbxaktualisieren();
end;

procedure TformMain.cbxSpeziellChange(Sender: TObject);
begin
  cds1.Filter := 'Speziell = ' + quotedstr(cbxSpeziell.Text);
  cds1.Filtered := true;
  moduszeigen('speziell');
  cds1.RecNo := cds1.RecordCount;
  dsaktualisieren();
  lbxaktualisieren();
end;

procedure TformMain.cbxDatumChange(Sender: TObject);
begin
  cds1.Filter := 'Datum = ' + quotedstr(cbxDatum.Text);
  cds1.Filtered := true;
  moduszeigen('datum');
  cds1.RecNo := cds1.RecordCount;
  dsaktualisieren();
  lbxaktualisieren();
end;

procedure TformMain.cbxBuchstabeChange(Sender: TObject);
begin
  if cbxBuchstabe.Text = '#' then
  begin
    cds1.Filter := 'Titel <> '+quotedstr('a*')+' and '
                  +'Titel <> '+quotedstr('b*')+' and '
                  +'Titel <> '+quotedstr('c*')+' and '
                  +'Titel <> '+quotedstr('d*')+' and '
                  +'Titel <> '+quotedstr('e*')+' and '
                  +'Titel <> '+quotedstr('f*')+' and '
                  +'Titel <> '+quotedstr('g*')+' and '
                  +'Titel <> '+quotedstr('h*')+' and '
                  +'Titel <> '+quotedstr('i*')+' and '
                  +'Titel <> '+quotedstr('j*')+' and '
                  +'Titel <> '+quotedstr('k*')+' and '
                  +'Titel <> '+quotedstr('l*')+' and '
                  +'Titel <> '+quotedstr('m*')+' and '
                  +'Titel <> '+quotedstr('n*')+' and '
                  +'Titel <> '+quotedstr('o*')+' and '
                  +'Titel <> '+quotedstr('p*')+' and '
                  +'Titel <> '+quotedstr('q*')+' and '
                  +'Titel <> '+quotedstr('r*')+' and '
                  +'Titel <> '+quotedstr('s*')+' and '
                  +'Titel <> '+quotedstr('t*')+' and '
                  +'Titel <> '+quotedstr('u*')+' and '
                  +'Titel <> '+quotedstr('v*')+' and '
                  +'Titel <> '+quotedstr('w*')+' and '
                  +'Titel <> '+quotedstr('x*')+' and '
                  +'Titel <> '+quotedstr('y*')+' and '
                  +'Titel <> '+quotedstr('z*')+' and '
                  +'Titel <> '+quotedstr('*')+' and '
                  +'Titel <> '+quotedstr('*')+' and '
                  +'Titel <> '+quotedstr('*');
  end
  else if cbxBuchstabe.text = 'A'then
  begin
    cds1.Filter := 'Titel = ' + quotedstr('A*') + ' or Titel = ' + quotedstr('*');
  end
  else if cbxBuchstabe.Text = 'O' then
  begin
    cds1.Filter := 'Titel = ' + quotedstr('O*') + ' or Titel = ' + quotedstr('*');
  end
  else if cbxBuchstabe.Text = 'U' then
  begin
    cds1.Filter := 'Titel = ' + quotedstr('U*') + ' or Titel = ' + quotedstr('*');
  end
  else
  begin
    cds1.Filter := 'Titel = ' + quotedstr(copy(cbxBuchstabe.Text,1,1) + '*');
  end;
  cds1.Filtered := true;
  moduszeigen('titel');
  if cds1.RecordCount <> 0 then
  begin
    cds1.RecNo := cds1.RecordCount;
  end;
  dsaktualisieren();
  lbxaktualisieren();
end;

procedure TformMain.cbxStichwortChange(Sender: TObject);
begin
  cds1.Filter := 'Stichworte like ' + quotedstr('%' + cbxStichwort.Text + '%');
  cds1.Filtered := true;
  moduszeigen('stichwort');
  cds1.RecNo := cds1.RecordCount;
  dsaktualisieren();
  lbxaktualisieren();
end;

procedure TformMain.btnSuchenClick(Sender: TObject);
begin
  cds1.Filter := 'Titel like ' + quotedstr('%' + ebxSuchen.Text + '%')
    + ' or Stichworte like ' + quotedstr('%' + ebxSuchen.Text + '%')
    + ' or Beschreibung like ' + quotedstr('%' + ebxSuchen.Text + '%');
  cds1.Filtered := true;
  moduszeigen('suchen');
  if cds1.RecordCount <> 0 then
  cds1.RecNo := cds1.RecordCount;
  dsaktualisieren();
  lbxaktualisieren();
end;

//########################################################################

function Explode(const Separator, S: string; Limit: Integer = 0): TStringDynArray;
var 
  SepLen: Integer; 
  F, P: PChar; 
  ALen, Index: Integer; 
begin 
  SetLength(Result, 0); 
  if (S = '') or (Limit < 0) then Exit; 
  if Separator = '' then 
  begin 
    SetLength(Result, 1); 
    Result[0] := S; 
    Exit; 
  end; 
  SepLen := Length(Separator); 
  ALen := Limit; 
  SetLength(Result, ALen); 
  Index := 0;
  P := PChar(S); 
  while P^ <> #0 do 
  begin 
    F := P; 
    P := StrPos(P, PChar(Separator)); 
    if (P = nil) or ((Limit > 0) and (Index = Limit - 1)) then P := StrEnd(F); 
    if Index >= ALen then 
    begin 
      Inc(ALen, 5); // mehrere auf einmal um schneller arbeiten zu knnen 
      SetLength(Result, ALen); 
    end; 
    SetString(Result[Index], F, P - F); 
    Inc(Index); 
    if P^ <> #0 then Inc(P, SepLen); 
  end; 
  if Index < ALen then SetLength(Result, Index); // wirkliche Lnge festlegen 
end;

//---------------------------------------------------------------------------
procedure dsaktualisieren();                       // Datensatz aktualisieren
begin
  // aus DB holen
  // Datensatzmaske aktualisieren
  formMain.ebxDatum.Text := formMain.cds1Datum.Text;
  formMain.ebxSpeziell.Text := formMain.cds1Speziell.Text;
  formMain.ebxTitel.Text := formMain.cds1Titel.Text;
  formMain.ebxStichworte.Text := formMain.cds1Stichworte.Text;
  formMain.ebxBeschreibung.Text := formMain.cds1Beschreibung.Value;
  formMain.ebxDsnr.Text := inttostr(formMain.cds1.recno);
  formMain.ebxDsanzahl.Text := inttostr(formMain.cds1.recordcount);
  if formMain.cds1.RecordCount = 0 then
  begin
    formMain.btnDelete.Enabled := false;
  end
  else
  begin
    formMain.btnDelete.Enabled := true;
  end;
  if (formmain.cds1.RecNo = formMain.cds1.RecordCount) or (formMain.cds1.RecordCount = 0) then
  begin
    formMain.btnNext.Enabled := false;
    formMain.btnLast.Enabled := false;
  end
  else
  begin
    formMain.btnNext.enabled := true;
    formMain.btnLast.Enabled := true;
  end;

  if (formmain.cds1.RecNo = 1) or (formMain.cds1.RecordCount = 0) then
  begin
    formMain.btnPrior.Enabled := false;
    formMain.btnFirst.Enabled := false;
  end
  else
  begin
    formMain.btnPrior.enabled := true;
    formMain.btnFirst.Enabled := true;
  end;
end;

//----------------------------------------------------------------------------
procedure cbxaktualisieren();                          // die Comboboxen fllen
  var i,ii,iii,iv,alterindex,minpos: integer;
  var h: string;
  var dsdatum, dsspeziell, dsstichworte: array of string;
  var enthalten: boolean;
  var hstichworte: TStringDynArray;
begin
  // alte RecNo speichern
    alterindex := formMain.cds1.RecNo;
  // Filter abschalten
    formMain.cds1.Filtered := false;
  // Datum sammeln
    ii := 0;
    for i := 1 to formMain.cds1.RecordCount do
    begin
      formMain.cds1.RecNo := i;
      h := vartostr(formMain.cds1.FieldValues['Datum']);
      if h <> '' then
      begin
        enthalten := false;
        for iii := low(dsdatum) to high(dsdatum) do
        begin
          if dsdatum[iii] = h then
          begin
            enthalten := true;
          end;
        end;
        if enthalten = false then
        begin
          ii := ii + 1;
          setlength(dsdatum, ii);
          dsdatum[ii-1] := h;
        end;
      end;
    end;
  // Datum sortieren
    for i := 0 to high(dsDatum)-1 do
    begin
      minpos := i;
      for ii := i+1 to high(dsDatum) do
      begin
        if comparedate(strtodate(dsDatum[ii]),strtodate(dsDatum[minpos])) > 0 then
        begin
          minpos := ii;
        end;
      end;
      h := dsDatum[i];
      dsDatum[i] := dsDatum[minpos];
      dsDatum[minpos] := h;
    end;
  // Speziell sammeln
    ii := 0;
    for i := 1 to formMain.cds1.RecordCount do
    begin
      formMain.cds1.RecNo := i;
      h := vartostr(formMain.cds1.FieldValues['Speziell']);
      if h <> '' then
      begin
        enthalten := false;
        for iii := low(dsspeziell) to high(dsspeziell) do
        begin
          if dsspeziell[iii] = h then
          begin
            enthalten := true;
          end;
        end;
        if enthalten = false then
        begin
          ii := ii + 1;
          setlength(dsspeziell, ii);
          dsspeziell[ii-1] := h;
        end;
      end;
    end;
  // Speziell sortieren
    for i := 0 to high(dsspeziell)-1 do
    begin
      minpos := i;
      for ii := i+1 to high(dsspeziell) do
      begin
        if ansicomparetext(dsspeziell[ii],dsspeziell[minpos]) < 0 then
        begin
          minpos := ii;
        end;
      end;
      h := dsspeziell[i];
      dsspeziell[i] := dsspeziell[minpos];
      dsspeziell[minpos] := h;
    end;
  // Stichworte sammeln
    ii := 0;
    for i := 1 to formMain.cds1.RecordCount do
    begin
      formMain.cds1.RecNo := i;
      h := vartostr(formMain.cds1.FieldValues['Stichworte']);
      if h <> '' then
      begin
        hstichworte := explode(',', h);
        for iv := 0 to High(hstichworte) do
        begin
          enthalten := false;
          for iii := 0 to high(dsstichworte) do
          begin
            if lowercase(dsstichworte[iii]) = lowercase(hstichworte[iv]) then
            begin
              enthalten := true;
            end;
          end;
          if (enthalten = false) and (hstichworte[iv] <> '') then
          begin
            ii := ii + 1;
            setlength(dsstichworte, ii);
            dsstichworte[ii-1] := hstichworte[iv];
          end;
        end;
      end;
    end;
  // Stichworte sortieren
    for i := 0 to high(dsStichworte)-1 do
    begin
      minpos := i;
      for ii := i+1 to high(dsstichworte) do
      begin
        if ansicomparetext(dsStichworte[ii],dsStichworte[minpos]) < 0 then
        begin
          minpos := ii;
        end;
      end;
      h := dsStichworte[i];
      dsStichworte[i] := dsStichworte[minpos];
      dsStichworte[minpos] := h;
    end;
  // Comboboxen leeren
    formMain.cbxDatum.Items.Clear;
    formMain.cbxSpeziell.Items.Clear;
    formMain.cbxStichwort.Items.Clear;
  // die Arrays in die Comboboxen bertragen
    for i:=0 to high(dsdatum) do
    begin
      formMain.cbxDatum.Items.Append(dsdatum[i]);
    end;
    for i:=0 to high(dsspeziell) do
    begin
      formMain.cbxSpeziell.Items.Append(dsspeziell[i]);
    end;
    for i:=0 to high(dsstichworte) do
    begin
      formMain.cbxStichwort.Items.Append(dsstichworte[i]);
    end;
  // Filter einschalten
    formMain.cds1.Filtered := true;
  // alte RecNo wiederherstellen
    formMain.cds1.RecNo := alterindex;
end;

//--------------------------------------------------------------------------
procedure lbxaktualisieren();                                    // Listbox
  var i,alterindex: integer;
  var h: string;
begin
  // alte RecNo merken
    alterindex := formMain.cds1.RecNo;
  formMain.lbxTitel.Clear;
  for i := formMain.cds1.RecordCount downto 1 do
  begin
    formMain.cds1.RecNo := i;
    h := vartostr(formMain.cds1.FieldValues['Titel']);
    formMain.lbxTitel.Items.Add(h);
  end;
  // alte RecNo wiederherstellen
    formMain.cds1.RecNo := alterindex;
  // selected Item setzen
    if alterindex <= formMain.cds1.RecordCount then
    begin
      if formMain.cds1.RecordCount <> 0 then
      begin
        formMain.lbxTitel.Selected[formMain.cds1.RecordCount - formMain.cds1.RecNo] := true;
      end;
    end;
end;

//---------------------------------------------------------------------------
procedure moduszeigen(modus: string);
begin
  if modus = 'alle' then
  begin
    formMain.panAlle.BevelInner := bvLowered;
    formMain.panAlle.BevelOuter := bvRaised;
  end
  else
  begin
    formMain.panAlle.BevelInner := bvNone;
    formMain.panAlle.BevelOuter := bvNone;
  end;
  if modus = 'allgemein' then
  begin
    formMain.panAllgemein.BevelInner := bvLowered;
    formMain.panAllgemein.BevelOuter := bvRaised;
  end
  else
  begin
    formMain.panAllgemein.BevelInner := bvNone;
    formMain.panAllgemein.BevelOuter := bvNone;
  end;
  if modus = 'speziell' then
  begin
    formMain.panSpeziell.BevelInner := bvLowered;
    formMain.panSpeziell.BevelOuter := bvRaised;
  end
  else
  begin
    formMain.panSpeziell.BevelInner := bvNone;
    formMain.panSpeziell.BevelOuter := bvNone;
  end;
  if modus = 'datum' then
  begin
    formMain.panDatum.BevelInner := bvLowered;
    formMain.panDatum.BevelOuter := bvRaised;
  end
  else
  begin
    formMain.panDatum.BevelInner := bvNone;
    formMain.panDatum.BevelOuter := bvNone;
    formMain.cbxDatum.Text := '';
  end;
  if modus = 'titel' then
  begin
    formMain.panTitel.BevelInner := bvLowered;
    formMain.panTitel.BevelOuter := bvRaised;
  end
  else
  begin
    formMain.panTitel.BevelInner := bvNone;
    formMain.panTitel.BevelOuter := bvNone;
    formMain.cbxBuchstabe.Text := '';
  end;
  if modus = 'stichwort' then
  begin
    formMain.panStichwort.BevelInner := bvLowered;
    formMain.panStichwort.BevelOuter := bvRaised;
  end
  else
  begin
    formMain.panStichwort.BevelInner := bvNone;
    formMain.panStichwort.BevelOuter := bvNone;
    formMain.cbxStichwort.Text := '';
  end;
  if modus = 'suchen' then
  begin
    formMain.panSuchen.BevelInner := bvLowered;
    formMain.panSuchen.BevelOuter := bvRaised;
  end
  else
  begin
    formMain.panSuchen.BevelInner := bvNone;
    formMain.panSuchen.BevelOuter := bvNone;
    formMain.ebxSuchen.Text := '';
  end;
end;

procedure speichern();
begin
  // Speichern?
  if formMain.modified = 1 then
  begin
    if messagedlg('Die Daten speichern?',mtCustom,[mbYes, mbNo],0) = mrYes then
    begin
      if formMain.aktuelleDatei <> '' then
      begin
        formMain.cds1.savetofile(formMain.aktuelleDatei, dfXML);
      end
      else
      begin
        formMain.mnuSpeichernunterClick(formMain);
      end;
    end;
    formMain.modified := 0;
  end;
end;

//########################################################################

end.
